; IDE-DATA										
.equ IDE_DATA0_PORT					= PORTA
.equ IDE_DATA0_DDR					= DDRA
.equ IDE_DATA0_PIN					= PINA

.equ IDE_DATA1_PORT					= PORTB
.equ IDE_DATA1_DDR					= DDRB
.equ IDE_DATA1_PIN					= PINB
; IDE											
.equ IDE_WR_PIN_NR					= 0
.equ IDE_WR_PIN						= PIND
.equ IDE_WR_PORT					= PORTD
.equ IDE_WR_DDR						= DDRD

.equ IDE_RD_PIN_NR					= 1
.equ IDE_RD_PIN						= PIND
.equ IDE_RD_PORT					= PORTD
.equ IDE_RD_DDR						= DDRD

.equ IDE_IRQ_PIN_NR					= 2
.equ IDE_IRQ_PIN					= PIND
.equ IDE_IRQ_PORT					= PORTD
.equ IDE_IRQ_DDR					= DDRD

.equ IDE_A1_PIN_NR					= 3
.equ IDE_A1_PIN						= PIND
.equ IDE_A1_PORT					= PORTD
.equ IDE_A1_DDR						= DDRD

.equ IDE_A0_PIN_NR					= 4
.equ IDE_A0_PIN						= PIND
.equ IDE_A0_PORT					= PORTD
.equ IDE_A0_DDR						= DDRD

.equ IDE_CS0_PIN_NR					= 5
.equ IDE_CS0_PIN					= PIND
.equ IDE_CS0_PORT					= PORTD
.equ IDE_CS0_DDR					= DDRD

.equ IDE_CS1_PIN_NR					= 6
.equ IDE_CS1_PIN					= PIND
.equ IDE_CS1_PORT					= PORTD
.equ IDE_CS1_DDR					= DDRD

.equ IDE_A2_PIN_NR					= 7
.equ IDE_A2_PIN						= PIND
.equ IDE_A2_PORT					= PORTD
.equ IDE_A2_DDR						= DDRD

.equ STATUS_BSY 	=7;    Busy-Flag. Wenn das Bit gesetzt ist, sind alle anderen Bits ungltig und das Laufwerk ist beschftigt.	 
.equ STATUS_DRDY 	=6;    Drive Ready. Es knnen Befehle zur Festplatte gesendet werden.											  	
.equ STATUS_DF 		=5;    Device Fault. Es ist beim Schreiben von Daten zu einem Fehler gekommen.									  	
.equ STATUS_DSC 	=4;    Drive Seek Complete. Zeigt an, dass das Laufwerk den angeforderten Track gefunden hat und die Schreib-/Lesekpfe dort positioniert hat.  	
.equ STATUS_DRQ 	=3;    Zeigt an, dass Daten zum Laufwerk transportiert werden sollen (beim Schreiben), bzw. dass Daten vom Laufwerk abgeholt werden knnen (beim Lesen).  	
.equ STATUS_COR 	=2;    Corrected Data. Wenn Daten von der Elektronik korrigiert worden sind, wird dieses Bit gesetzt.			  	
.equ STATUS_IDX 	=1;    Index. Wird bei jeder Umdrehung des Plattenstapels auf 1 gesetzt.										  	
.equ STATUS_ERR 	=0;    Error. Das Error-Register muss ausgelesen werden, um nhere Informationen zu erhalten.					  

.equ CS0=4		; Codierung
.equ CS1=3 		
.equ DA2=2	
.equ DA1=1 
.equ DA0=0
; wichtige Register														  ;/CS0 /CS1 		DA2	DA1 DA0	
.equ Reg_R_Alternate_Status	=(1<<CS0)|(0<<CS1)|	(1<<DA2)|(1<<DA1)|(0<<DA0)	; 1 	0 		1 	1 	0 	
.equ Reg_W_Device_Control	=(1<<CS0)|(0<<CS1)|	(1<<DA2)|(1<<DA1)|(0<<DA0)	; 1 	0 		1 	1 	0 	
.equ Reg_R_NA				=(1<<CS0)|(0<<CS1)|	(1<<DA2)|(1<<DA1)|(1<<DA0)	; 1 	0 		1 	1 	1 	N/A 				N/A						
.equ Reg_W_NA				=(1<<CS0)|(0<<CS1)|	(1<<DA2)|(1<<DA1)|(1<<DA0)	; 1 	0 		1 	1 	1 	N/A 				N/A						
.equ Reg_Data_Register		=(0<<CS0)|(1<<CS1)|	(0<<DA2)|(0<<DA1)|(0<<DA0)	; 0 	1 		0 	0 	0 	Data Register 		Data Register			
.equ Reg_R_Error_Register	=(0<<CS0)|(1<<CS1)|	(0<<DA2)|(0<<DA1)|(1<<DA0)	; 0 	1 		0 	0 	1 	Error Register 		Features Register		
.equ Reg_W_Features_Register=(0<<CS0)|(1<<CS1)|	(0<<DA2)|(0<<DA1)|(1<<DA0)	; 0 	1 		0 	0 	1 	Error Register 		Features Register		
.equ Reg_Sector_Count		=(0<<CS0)|(1<<CS1)|	(0<<DA2)|(1<<DA1)|(0<<DA0)	; 0 	1 		0 	1 	0 	Sector Count 		Sector Count			
.equ Reg_Sector_Number		=(0<<CS0)|(1<<CS1)|	(0<<DA2)|(1<<DA1)|(1<<DA0)	; 0 	1 		0 	1 	1 	Sector Number / LBA Bits 0..7 	Sector Number / LBA Bits 0..7
.equ Reg_Cylinder_L			=(0<<CS0)|(1<<CS1)|	(1<<DA2)|(0<<DA1)|(0<<DA0)	; 0 	1 		1 	0 	0 	Cylinder Low  / LBA Bits 8..15 	Cylinder Low / LBA Bits 8..15
.equ Reg_Cylinder_H			=(0<<CS0)|(1<<CS1)|	(1<<DA2)|(0<<DA1)|(1<<DA0)	; 0 	1 		1 	0 	1 	Cylinder High / LBA Bits 16..23 	Cylinder High / LBA Bits 16..23
.equ Reg_Device_Register	=(0<<CS0)|(1<<CS1)|	(1<<DA2)|(1<<DA1)|(0<<DA0)	; 0 	1 		1 	1 	0 	Device Register & LBA Bits 24..27 	Device Register & LBA Bits 24..27
.equ Reg_R_Status_Register	=(0<<CS0)|(1<<CS1)|	(1<<DA2)|(1<<DA1)|(1<<DA0)	; 0 	1 		1 	1 	1 	Status Register 	Command Register 
.equ Reg_W_Command_Register	=(0<<CS0)|(1<<CS1)|	(1<<DA2)|(1<<DA1)|(1<<DA0)	; 0 	1 		1 	1 	1 	Status Register 	Command Register 

;Error Register																												
;Bit 7 	Bit 6 	Bit 5 	Bit 4 	Bit 3 	Bit 2 	Bit 1 	Bit 0																
;CRC 	UNC 	0 		IDNF 	0 		ABRT 	TK0NF 	AMNF																
;CRC bedeutet, dass bei einem DMA-Transfer ein CRC-Fehler aufgetreten ist. 													
;UNC gibt an, dass bei einer Datenbertragung ein Fehler erkannt worden ist, dieser aber nicht korrigiert werden konnte. 	
;IDNF zeigt an, dass der angeforderte Sektor nicht gefunden worden ist. 													
;ABRT wird auf 1 gesetzt, wenn ein Befehl abgebrochen (aborted) wurde. 														
;TK0NF Zeigt an, dass Track 0 nicht gefunden worden ist. 																	
;AMNF (Address Mark not found): Zeigt an, dass der gewnschte Sektor zwar gefunden wurde, seine Daten aber nicht. 			
;																															

; Device Register & LBA Bits 24..27																							
; Im Device Register stehen folgende Bits:																					
; Bit 7 	Bit 6 	Bit 5 	Bit 4 	Bit 3 	 Bit 2 		Bit 1 		Bit 0													
;	1 		L 		1 		DRV 	H3/LBA27 H2/LBA26 	H1/LBA25 	H0/LBA24												
; L=1=LBA-Modus / (L = 0 =CHS-Adressierung). 																				
; DRV dient zur Adressierung eines Laufwerks, also zur Unterscheidung Master / Slave und ist nur ntig, wenn man 2 Laufwerke an einem Kabel betreibt. 
; DRV = 0 whlt das Master-Laufwerk aus, DRV = 1 adressiert das Slave-Laufwerk. 											
; H0..H3 geben die Nummer des Kopfes an, wenn CHS-Adressierung verwendet wird. Wird LBA verwendet, dann kommen hier die Bits 24..27 hin. 


; Features Register
;Das Features Register bekommt, je nach ausgefhrtem Befehl, eine andere Bedeutung.

;Cylinder High / LBA Bits 16..23

;Hier kommt das High Byte der Zylindernummer rein, wenn man CHS-Adressierung verwendet. Setzt man LBA ein, dann mssen hier die entsprechenden LBA Bits geschrieben werden.
;Cylinder Low / LBA Bits 8..15

;Das Low-Byte der Zylindernummer bei CHS-Adressierung; Bits 8..15 bei LBA-Adressierung.
;Sector Number / LBA Bits 0..7

;Wenn man mit CHS arbeitet, muss hier die Sektornummer stehen. Achtung: Sektoren werden von 1 her beginnend Adressiert! Bei LBA werden hier die Bits 0..7 platziert.

;Sector Count Register
;Hier kann man angeben, wie viele Sektoren man beim nchsten Befehl bertragen mchte. Die Festplatte kann bis 256 Sektoren auf einmal lesen. 

.equ Command_Identify_Device= 0xEC ; Gibt Infos wie Modell, Hersteller, Kapazitt... aus	
.equ Command_Read_Sector 	= 0x21 ; Liest die gewnschte Anzahl Sektoren von der Platte	
.equ Command_Read_Sectors 	= 0x20 ; Liest die gewnschte Anzahl Sektoren von der Platte	
.equ Command_Seek 			= 0x70 ; Positioniert die Schreib-/Lesekpfe ber dem angegebenen Sektor								
.equ Command_Standby 		= 0xE2 ; Schaltet die Platte aus. Sie wird autom. wieder aktiv, wenn man ihr einen neuen Befehl sendet.	
.equ Command_Write_Sector 	= 0x30 ; Schreibt die gewnschte Anzahl Sektoren auf die Platte. 										
.equ Command_Write_Sectors 	= 0x31 ; Schreibt die gewnschte Anzahl Sektoren auf die Platte. 										




; ##############################################################################
; ##############################################################################
; ##############################################################################
IDE_INITIALISIERUNG:
	OUT(IDE_DATA0_DDR), NULL			; auf EINGANG					
	OUT(IDE_DATA1_DDR), NULL
	OUT(IDE_DATA0_PORT),VOLL			; Pull-Up ein					
	OUT(IDE_DATA1_PORT),VOLL

	cbi(IDE_IRQ_DDR),(IDE_IRQ_PIN_NR)	; auf EINGANG					
	sbi(IDE_IRQ_PORT),(IDE_IRQ_PIN_NR)	; Pull-Up ein					

	sbi(IDE_WR_PORT) ,(IDE_WR_PIN_NR)	; auf HIGH						
	sbi(IDE_RD_PORT) ,(IDE_RD_PIN_NR)

	sbi(IDE_WR_DDR) ,(IDE_WR_PIN_NR)	; auf Ausgang					
	sbi(IDE_RD_DDR) ,(IDE_RD_PIN_NR)
	sbi(IDE_A0_DDR) ,(IDE_A0_PIN_NR)
	sbi(IDE_A1_DDR) ,(IDE_A1_PIN_NR)
	sbi(IDE_A2_DDR) ,(IDE_A2_PIN_NR)
	sbi(IDE_CS0_DDR),(IDE_CS0_PIN_NR)
	sbi(IDE_CS1_DDR),(IDE_CS1_PIN_NR)

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
IDE_PAUSE:
	rcall WAIT_1us
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
IDE_WAIT_BUSHY:
	WDR
;	ldi temp1,(Reg_R_Status_Register)	; lscht den Interrupt		
	ldi temp1,(Reg_R_Alternate_Status)	; ohne Interrupt Lschung	
	rcall IDE_REGISTER_READ_TEMP1

	SBRC temp1,(STATUS_BSY)
	cbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)		; GELB an	

	SBRC temp1,(STATUS_BSY)
	rjmp IDE_WAIT_BUSHY
;-------------------------------------------------------------------------------
	sbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)		; GELB aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
;Bit 7 	Bit 6 	Bit 5 	Bit 4 	Bit 3 	Bit 2 	Bit 1 	Bit 0					
;BSY 	DRDY 	DF 		DSC 	DRQ 	COR 	IDX 	ERR						
;																				
; 0x50=OK																		
; 0x80=																			
; 0xFF=HDD aus																	
IDE_STATUS_ABFRAGEN_TEMP1:
	WDR
;	ldi temp1,(Reg_R_Status_Register)	; lscht den Interrupt		
	ldi temp1,(Reg_R_Alternate_Status)	; ohne Interrupt Lschung	
	rcall IDE_REGISTER_READ_TEMP1
	STS(adr_IDE_STATUS),temp1
;-------------------------------------------------------------------------------
	cpi temp1,0xFF
	breq IDE_STATUS_ABFRAGEN_ERROR
;-------------------------------------------------------------------------------
	SBRC temp1,(STATUS_DRDY)
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an 	
	SBRS temp1,(STATUS_DRDY)
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
;-------------------------------------------------------------------------------
	SBRC temp1,(STATUS_BSY)
	cbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)		; GELB an	

	SBRC temp1,(STATUS_BSY)
	rjmp IDE_STATUS_ABFRAGEN_TEMP1				; Schleife	

	SBRS temp1,(STATUS_BSY)
	sbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)		; GELB aus	
;-------------------------------------------------------------------------------

	SBRC temp1,(STATUS_ERR)
	cbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  an	
;	SBRS temp1,(STATUS_ERR)
;	sbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  aus	
ret
;-------------------------------------------------------------------------------
; z.B. HDD nicht vorhanden 5V/12V fehlt											
IDE_STATUS_ABFRAGEN_ERROR:
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	sbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)		; GELB aus	
	sbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  aus	
	rcall WAIT_100ms
	cbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  an	
	rcall WAIT_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;/CS0 /CS1 		DA2	DA1 DA0	Register (Read) 	Register (Write)				
; 0 	1 		1 	1 	1 	Status Register 	Command Register 				
;Standby 	0xE2 	Schaltet die Platte aus. Sie wird autom. wieder aktiv, wenn man ihr einen neuen Befehl sendet. 
IDE_SLEEP:
	ldi temp1,(Reg_W_Command_Register)
	ldi temp2,(Command_Standby)
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Bit 7 	Bit 6 	Bit 5 	Bit 4 	Bit 3 	Bit 2 	Bit 1 	Bit 0				
;									  1 	SRST 	nIEN 	  0					
;																			 	
; SRST auf 1, so wird ein Software Reset durchgefhrt. 							
; Mit nIEN kann man die Interrupts ein- oder ausschalten. 						
IDE_RESET:
	ldi temp1,(Reg_W_Device_Control)
	ldi temp2,(0b00001100)
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2

	ldi temp1,(Reg_W_Device_Control)
	ldi temp2,(0b00000000)
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
	rcall IDE_STATUS_ABFRAGEN_TEMP1
	rcall WAIT_1s
	rcall IDE_WAIT_BUSHY				; wait BUSHY	
	rcall WAIT_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
IDE_SECTOR_INITIALISIERUNG:
.equ CYL=51	; test
	ldi temp1,(Reg_Sector_Count)	; Sector Count schreiben	
	ldi temp2,(1)					; 1 Sector (512 Bytes)		
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
	rcall IDE_WAIT_BUSHY			; wait BUSHY				

	ldi temp1,(Reg_Sector_Number)	; Sector Number schreiben	
	ldi temp2,(1)					; mit 1 beginnend
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
	rcall IDE_WAIT_BUSHY			; wait BUSHY				

	ldi temp1,(Reg_Cylinder_L)		; Cylinder Low schreiben	
	ldi temp2,LOW(CYL)	; test
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
	rcall IDE_WAIT_BUSHY			; wait BUSHY				

	ldi temp1,(Reg_Cylinder_H)		; Cylinder HIGH schreiben	
	ldi temp2,HIGH(CYL)	; test
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
	rcall IDE_WAIT_BUSHY			; wait BUSHY				

	ldi temp1,(Reg_Device_Register)	; 
	ldi temp2,LOW(0)
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
	rcall IDE_WAIT_BUSHY			; wait BUSHY				

	ldi temp1,(Reg_W_Command_Register)
	ldi temp2,(Command_Seek)		; SEEK
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
	rcall IDE_WAIT_BUSHY			; wait BUSHY	

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
IDE_SECTOR_WRITE:
	rcall IDE_SECTOR_INITIALISIERUNG
;-------------------------------------------------------------------------------
	ldi temp1,(Reg_W_Command_Register)
	ldi temp2,(Command_Write_Sector)
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
	rcall IDE_WAIT_BUSHY			; wait BUSHY	
;-------------------------------------------------------------------------------
; Schleife																		
IDE_SECTOR_WRITE_s:
	cbi(IDE_CS0_PORT),(IDE_CS0_PIN_NR)	; CS0=L		; DATA	
	sbi(IDE_CS1_PORT),(IDE_CS1_PIN_NR)	; CS1=H		
	cbi(IDE_A2_PORT) ,(IDE_A2_PIN_NR)	; A2 =L		
	cbi(IDE_A1_PORT) ,(IDE_A1_PIN_NR)	; A1 =L		
	cbi(IDE_A0_PORT) ,(IDE_A0_PIN_NR)	; A0 =L		
	OUT(IDE_DATA0_DDR), VOLL			; auf AUSGANG	
	OUT(IDE_DATA1_DDR), VOLL
;-------------------------------------------------------------------------------
	ldi temp1,0xAA	; Test-Data	
	ldi temp2,0xBB	; Test-Data	
	OUT(IDE_DATA0_PORT),temp1			; DATA write	
	OUT(IDE_DATA1_PORT),temp2
	rcall IDE_PAUSE						; PAUSE		
;-------------------------------------------------------------------------------
	cbi(IDE_WR_PORT) ,(IDE_WR_PIN_NR) 	;WR=L		
	rcall IDE_PAUSE						; PAUSE		
	sbi(IDE_WR_PORT) ,(IDE_WR_PIN_NR) 	;WR=H		
	rcall IDE_PAUSE						; PAUSE		
;-------------------------------------------------------------------------------
	rcall IDE_STATUS_ABFRAGEN_TEMP1
	SBRC temp1,(STATUS_DRQ)				; warten auf Daten
	rjmp IDE_SECTOR_WRITE_s
	rcall IDE_STATUS_ABFRAGEN_TEMP1
;	rcall IDE_RESET
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
IDE_SECTOR_READ:
	rcall IDE_SECTOR_INITIALISIERUNG
;-------------------------------------------------------------------------------
	ldi temp1,(Reg_W_Command_Register)
	ldi temp2,(Command_Read_Sector)
	rcall IDE_REGISTER_WRITE_TEMP1_TEMP2
	rcall IDE_WAIT_BUSHY				; wait BUSHY	
;-------------------------------------------------------------------------------
; auf EINGANG																	
	OUT(IDE_DATA0_PORT),VOLL			; Pull-Up ein					
	OUT(IDE_DATA1_PORT),VOLL
	OUT(IDE_DATA0_DDR), NULL			; auf EINGANG					
	OUT(IDE_DATA1_DDR), NULL
;-------------------------------------------------------------------------------
	ldi ZL,LOW (adr_IDE_DATA)			; Z-DATA	
	ldi ZH,HIGH(adr_IDE_DATA)
;-------------------------------------------------------------------------------
IDE_SECTOR_READ_s:
;-------------------------------------------------------------------------------
; DATA																			
	cbi(IDE_CS0_PORT),(IDE_CS0_PIN_NR)	; CS0=L		
	sbi(IDE_CS1_PORT),(IDE_CS1_PIN_NR)	; CS1=H		
	cbi(IDE_A2_PORT) ,(IDE_A2_PIN_NR)	; A2 =L		
	cbi(IDE_A1_PORT) ,(IDE_A1_PIN_NR)	; A1 =L		
	cbi(IDE_A0_PORT) ,(IDE_A0_PIN_NR)	; A0 =L		
	rcall IDE_PAUSE						; PAUSE		
;-------------------------------------------------------------------------------
; read																			
	cbi(IDE_RD_PORT),(IDE_RD_PIN_NR)	; RD=L		
	rcall IDE_PAUSE						; PAUSE		
	in temp,(IDE_DATA0_PIN)		 		; read		
	ST Z+,temp							; DATA0-->Z	
	in temp,(IDE_DATA1_PIN)		 		; read		
	ST Z+,temp							; DATA1-->Z	
	sbi(IDE_RD_PORT) ,(IDE_RD_PIN_NR)	; RD=H		
	rcall IDE_PAUSE					
;-------------------------------------------------------------------------------
; Schleife																		
	rcall IDE_STATUS_ABFRAGEN_TEMP1
	SBRC temp1,(STATUS_DRQ)
	rjmp IDE_SECTOR_READ_s
;-------------------------------------------------------------------------------
	rcall IDE_WAIT_BUSHY				; wait BUSHY	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp1 (IDE-Register)														
; OUT: temp1																		
IDE_REGISTER_READ_TEMP1:
	sbrc temp1,(CS1)						; Skip if Bit	
	sbi(IDE_CS1_PORT),(IDE_CS1_PIN_NR)	; H				
	sbrs temp1,(CS1)						; Skip if Bit	
	cbi(IDE_CS1_PORT),(IDE_CS1_PIN_NR)	; L				
	sbrc temp1,(CS0)						; Skip if Bit	
	sbi(IDE_CS0_PORT),(IDE_CS0_PIN_NR)	; H				
	sbrs temp1,(CS0)						; Skip if Bit	
	cbi(IDE_CS0_PORT),(IDE_CS0_PIN_NR)	; L				
	sbrc temp1,(DA2)						; Skip if Bit	
	sbi(IDE_A2_PORT) ,(IDE_A2_PIN_NR) 	; H				
	sbrs temp1,(DA2)						; Skip if Bit	
	cbi(IDE_A2_PORT) ,(IDE_A2_PIN_NR) 	; L				
	sbrc temp1,(DA1)						; Skip if Bit	
	sbi(IDE_A1_PORT) ,(IDE_A1_PIN_NR) 	; H				
	sbrs temp1,(DA1)						; Skip if Bit	
	cbi(IDE_A1_PORT) ,(IDE_A1_PIN_NR)	; L				
	sbrc temp1,(DA0)						; Skip if Bit	
	sbi(IDE_A0_PORT) ,(IDE_A0_PIN_NR) 	; H				
	sbrs temp1,(DA0)						; Skip if Bit	
	cbi(IDE_A0_PORT) ,(IDE_A0_PIN_NR) 	; L				
;-------------------------------------------------------------------------------
	OUT(IDE_DATA0_DDR), NULL			; auf EINGANG					
	OUT(IDE_DATA1_DDR), NULL
	OUT(IDE_DATA0_PORT),VOLL			; Pull-Up ein					
	OUT(IDE_DATA1_PORT),VOLL
	rcall IDE_PAUSE					; PAUSE	
;-------------------------------------------------------------------------------
	cbi(IDE_RD_PORT) ,(IDE_RD_PIN_NR)	;0
	rcall IDE_PAUSE					; PAUSE	
	in temp1,(IDE_DATA0_PIN)		 	; read	
	sbi(IDE_RD_PORT) ,(IDE_RD_PIN_NR) 	;1
	rcall IDE_PAUSE					; PAUSE	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; temp1: Register																
; temp2: Wert																	
IDE_REGISTER_WRITE_TEMP1_TEMP2:
	sbrc temp1,(CS1)					; Skip if Bit	
	sbi(IDE_CS1_PORT),(IDE_CS1_PIN_NR)	; H				
	sbrs temp1,(CS1)					; Skip if Bit	
	cbi(IDE_CS1_PORT),(IDE_CS1_PIN_NR)	; L				
	sbrc temp1,(CS0)					; Skip if Bit	
	sbi(IDE_CS0_PORT),(IDE_CS0_PIN_NR)	; H				
	sbrs temp1,(CS0)					; Skip if Bit	
	cbi(IDE_CS0_PORT),(IDE_CS0_PIN_NR)	; L				
	sbrc temp1,(DA2)					; Skip if Bit	
	sbi(IDE_A2_PORT) ,(IDE_A2_PIN_NR) 	; H				
	sbrs temp1,(DA2)					; Skip if Bit	
	cbi(IDE_A2_PORT) ,(IDE_A2_PIN_NR) 	; L				
	sbrc temp1,(DA1)					; Skip if Bit	
	sbi(IDE_A1_PORT) ,(IDE_A1_PIN_NR) 	; H				
	sbrs temp1,(DA1)					; Skip if Bit	
	cbi(IDE_A1_PORT) ,(IDE_A1_PIN_NR)	; L				
	sbrc temp1,(DA0)					; Skip if Bit	
	sbi(IDE_A0_PORT) ,(IDE_A0_PIN_NR) 	; H				
	sbrs temp1,(DA0)					; Skip if Bit	
	cbi(IDE_A0_PORT) ,(IDE_A0_PIN_NR) 	; L				
;-------------------------------------------------------------------------------
	OUT(IDE_DATA0_DDR),VOLL				; auf Ausgang	
	OUT(IDE_DATA1_DDR),VOLL
	OUT(IDE_DATA0_PORT),temp2			; DATA write	
	OUT(IDE_DATA1_PORT),NULL			
	rcall IDE_PAUSE					; PAUSE	
;-------------------------------------------------------------------------------
	cbi(IDE_WR_PORT) ,(IDE_WR_PIN_NR) 	;0
	rcall IDE_PAUSE					; PAUSE	
	sbi(IDE_WR_PORT) ,(IDE_WR_PIN_NR) 	;1
	rcall IDE_PAUSE					; PAUSE	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
